/*	$Id: mouse.h,v 1.5 1996/10/12 17:19:01 sandro Exp $	*/

/*
 * Copyright (c) 1996
 *	Sandro Sigala, Brescia, Italy.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Sandro Sigala.
 * 4. Neither the name of the author nor the names of any contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _MOUSE_H_
#define _MOUSE_H_

#define PTR_WIDTH 16
#define PTR_HEIGHT 16

#define PTR_TRANSPARENT	2
#define PTR_WHITE	1
#define PTR_BLACK	0

#define PTR_HOTSPOT_X(p) p[0]
#define PTR_HOTSPOT_Y(p) p[1]
#define PTR_DATA(p,x,y) p[2+(x)+(y)*PTR_HEIGHT]

#define WMOUSE_RECT(x0,y0,x1,y1) \
	(wmouse_x >= (x0) && wmouse_y >= (y0) && \
	 wmouse_x <= (x1) && wmouse_y <= (y1))

extern int wmouse_xmin;
extern int wmouse_ymin;
extern int wmouse_xmax;
extern int wmouse_ymax;
extern int wmouse_x;
extern int wmouse_y;
extern int wmouse_oldx;
extern int wmouse_oldy;
extern int wmouse_button;
extern int wmouse_oldbutton;
extern int wmouse_status;
extern int wmouse_color_black;
extern int wmouse_color_white;

extern void wmouse_setpointer(char *);
extern void wmouse_show(void);
extern void wmouse_hide(void);
extern void wmouse_update(void);
extern void wmouse_update_window(int, int, int, int);
extern void wmouse_reset(void);

#endif /* !_MOUSE_H_ */
